/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Number.xs. Do not edit this file, edit Number.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Scalar/Number.xs"
#define PERL_NO_GET_CONTEXT 1
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifndef cBOOL
# define cBOOL(x) ((bool)!!(x))
#endif /* !cBOOL */

#define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#define PERL_DECIMAL_VERSION \
	PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#define PERL_VERSION_GE(r,v,s) \
	(PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))

#define Q_IOK_MAYBE_SPURIOUS (!PERL_VERSION_GE(5,7,1))
#define Q_STRING_ZERO_FLOATS \
	(PERL_VERSION_GE(5,13,6) && !PERL_VERSION_GE(5,17,1))

/*
 * The way an SV is interpreted for its numerical value varies between Perl
 * versions.  The new way (perl 5.7.1+) is that the IOK and NOK flags
 * strictly indicate that the numerical value is acceptably represented by
 * the corresponding field.  The old way (up to perl 5.7.0) is that the IOK
 * and NOK flags indicate that the corresponding field is filled, but it
 * might be a conversion from the other form.  In the old form, most
 * arithmetic is floating point, so to handle an integer that can't be
 * represented in floating point it must be specially processed using
 * integer-only operations, and so won't have NOK set.  So the rules are:
 *
 * STYLE IOK  NOK
 * old   no   no   use string_2num() to numerify, then try again
 * old   no   yes  use NV
 * old   yes  no   use IV/UV
 * old   yes  yes  use NV
 * new   no   no   use string_2num() to numerify, then try again
 * new   no   yes  use NV
 * new   yes  no   use IV/UV
 * new   yes  yes  use IV/UV
 *
 * Which set of rules applies is controlled by the Q_IOK_MAYBE_SPURIOUS flag.
 */

/*
 * string_2num() resolves a string SV into one that has the same numeric
 * value and has that numeric value expressed directly in the SV structure
 * (as either an IV, UV, or NV).  A mortal reference to the resulting SV
 * is returned.  The resulting SV is not necessarily a pure number; it may
 * have an unrelated string value.  Warns for non-numeric strings.
 */

#define string_2num(s) THX_string_2num(aTHX_ s)
static SV *THX_string_2num(pTHX_ SV *s)
{
	if(SvIOK(s) || SvNOK(s)) return s;
	s = sv_mortalcopy(s);
	if(!Q_IOK_MAYBE_SPURIOUS && (SvIV(s), SvIOK(s))) {
		if(Q_HAVE_SIGNED_ZERO && SvIVX(s) == 0) {
			/* It's a zero, and asking for SvIV has squashed
			 * it to an integer zero, but it wouldn't
			 * necessarily be considered an integer zero
			 * by other operations.  We seek to match the
			 * behaviour of the printf("%.f")-based test,
			 * thus regarding the behaviour of the negate
			 * operation canonical.
			 */
			if(Q_STRING_ZERO_FLOATS) {
				/* String zeroes now always turn into
				 * floating-point zeroes.
				 */
				sv_setnv(s, SvNV(s));
			} else {
				/* Preserve sign iff the string value
				 * starts with a sign character.
				 */
				char c = *SvPV_nolen(s);
				if(c == '-') {
					sv_setnv(s, -0.0);
					SvIOK_off(s);
				} else if(c == '+') {
					sv_setnv(s, 0.0);
					SvIOK_off(s);
				} else {
					sv_setiv(s, 0);
					SvNOK_off(s);
				}
			}
		}
	} else {
		NV val = SvNV(s);
		if(!SvNOK(s)) sv_setnv(s, val);
	}
	return s;
}

/*
 * numscl_val_cmp() does a value comparison on two scalars that express
 * their numeric values directly.  It must not be called on general
 * scalars.
 */

/* These variables store the values min_natint and max_natint+1,
   respectively, in floating-point form.  They are initialised by
   the boot function. */
static NV neg_natint_limit, pos_natint_limit;

#define numscl_val_cmp(a, b) THX_numscl_val_cmp(aTHX_ a, b)
static SV *THX_numscl_val_cmp(pTHX_ SV *a, SV *b)
{
	bool aiok, biok;
	int result;
	aiok = Q_IOK_MAYBE_SPURIOUS ? !SvNOK(a) : cBOOL(SvIOK(a));
	biok = Q_IOK_MAYBE_SPURIOUS ? !SvNOK(b) : cBOOL(SvIOK(b));
	if(aiok && biok) {
		if(SvIOK_UV(a)) {
			if(SvIOK_UV(b)) {
				UV au = SvUVX(a), bu = SvUVX(b);
				result = au < bu ? -1 : au == bu ? 0 : +1;
			} else {
				UV au = SvUVX(a);
				IV bi = SvIVX(b);
				result = bi < 0 ? +1 :
					au < ((UV)bi) ? -1 :
					au == ((UV)bi) ? 0 : +1;
			}
		} else {
			if(SvIOK_UV(b)) {
				IV ai = SvIVX(a);
				UV bu = SvUVX(b);
				result = ai < 0 ? -1 :
					((UV)ai) < bu ? -1 :
					((UV)ai) == bu ? 0 : +1;
			} else {
				IV ai = SvIVX(a), bi = SvIVX(b);
				result = ai < bi ? -1 : ai == bi ? 0 : +1;
			}
		}
	} else if(SvNOK(a) && SvNOK(b)) {
		NV an = SvNVX(a);
		NV bn = SvNVX(b);
		if(an != an || bn != bn)
			return &PL_sv_undef;
		result = an < bn ? -1 : an == bn ? 0 : +1;
	} else {
		bool reversed = biok;
		SV *x = reversed ? b : a, *y = reversed ? a : b;
		NV yn = SvNVX(y);
		UV xu;
		if(yn != yn)
			return &PL_sv_undef;
		if(SvIOK_UV(x)) {
			xu = SvUVX(x);
		} else {
			IV xi = SvIVX(x);
			xu = (UV)xi;
			if(xi < 0) {
				xu = -xu;
				yn = -yn;
				reversed = !reversed;
			}
		}
		if(yn < 0.0) {
			result = +1;
		} else if(yn >= pos_natint_limit) {
			result = -1;
		} else {
			UV yu = yn;
			result = xu < yu ? -1 : xu > yu ? +1 :
				yn - ((NV)yu) == 0.0 ? 0 : -1;
		}
		if(reversed)
			result = -result;
	}
	return newSViv(result);
}

#line 187 "lib/Scalar/Number.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 331 "lib/Scalar/Number.c"

XS_EUPXS(XS_Scalar__Number__warnable_scalar_num_part); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Scalar__Number__warnable_scalar_num_part)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "scalar");
    {
	SV *	RETVAL;
	SV *	scalar = ST(0)
;
#line 196 "lib/Scalar/Number.xs"
	while(!SvIOK(scalar) && !SvNOK(scalar) && SvROK(scalar)) {
		if(SvAMAGIC(scalar)) {
			SV *t = AMG_CALLun(scalar, numer);
			if(t && (!SvROK(t) || SvRV(t) != SvRV(scalar))) {
				scalar = t;
				continue;
			}
		}
		scalar = sv_2mortal(newSVuv(PTR2UV(SvRV(scalar))));
	}
	scalar = string_2num(scalar);
	if(Q_IOK_MAYBE_SPURIOUS && SvNOK(scalar)) {
		RETVAL = newSVnv(SvNVX(scalar));
	} else if(SvIOK_notUV(scalar)) {
		RETVAL = newSViv(SvIVX(scalar));
	} else if(SvIOK_UV(scalar)) {
		RETVAL = newSVuv(SvUVX(scalar));
	} else {
		RETVAL = newSVnv(SvNVX(scalar));
	}
#line 364 "lib/Scalar/Number.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Scalar__Number_sclnum_is_natint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Scalar__Number_sclnum_is_natint)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "scalar");
    {
	bool	RETVAL;
	SV *	scalar = ST(0)
;
#line 223 "lib/Scalar/Number.xs"
	scalar = string_2num(scalar);
	if(Q_IOK_MAYBE_SPURIOUS ? !SvNOK(scalar) : SvIOK(scalar)) {
		RETVAL = 1;
	} else {
		NV val = SvNVX(scalar);
		if(Q_HAVE_SIGNED_ZERO && val == 0.0) {
			RETVAL = 0;
		} else if(val < 0.0) {
			RETVAL = val >= neg_natint_limit &&
					((NV)(IV)val) == val;
		} else {
			RETVAL = val < pos_natint_limit &&
					((NV)(UV)val) == val;
		}
	}
#line 398 "lib/Scalar/Number.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Scalar__Number_sclnum_is_float); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Scalar__Number_sclnum_is_float)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "scalar");
    {
	bool	RETVAL;
	SV *	scalar = ST(0)
;
#line 245 "lib/Scalar/Number.xs"
	scalar = string_2num(scalar);
	if(SvNOK(scalar)) {
		RETVAL = !(Q_HAVE_SIGNED_ZERO && !Q_IOK_MAYBE_SPURIOUS &&
				SvIOK(scalar) && SvIVX(scalar) == 0);
	} else {
		UV mag = SvIOK_UV(scalar) ? SvUVX(scalar) :
			SvIVX(scalar) < 0 ? -(UV)SvIVX(scalar) : SvIVX(scalar);
		if(Q_HAVE_SIGNED_ZERO && mag == 0) {
			RETVAL = 0;
		} else {
#if Q_SIGNIFICAND_BITS+1 >= Q_NATINT_BITS
			/* all native integers are representable as floats
			 * (except possibly zero, handled above)
			 */
			RETVAL = 1;
#else /* Q_SIGNIFICAND_BITS+1 < Q_NATINT_BITS */
			/* check length of integer */
			RETVAL = 1;
			while(mag >= (((UV)1) << (Q_SIGNIFICAND_BITS+1))) {
				if(mag & 1) {
					RETVAL = 0;
					break;
				}
				mag >>= 1;
			}
#endif /* Q_SIGNIFICAND_BITS+1 < Q_NATINT_BITS */
		}
	}
#line 444 "lib/Scalar/Number.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Scalar__Number_sclnum_val_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Scalar__Number_sclnum_val_cmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	SV *	RETVAL;
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
#line 280 "lib/Scalar/Number.xs"
	RETVAL = numscl_val_cmp(string_2num(a), string_2num(b));
#line 465 "lib/Scalar/Number.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Scalar__Number_sclnum_id_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Scalar__Number_sclnum_id_cmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
#line 288 "lib/Scalar/Number.xs"
	bool aiok, biok;
	bool anan, bnan;
#line 483 "lib/Scalar/Number.c"
	SV *	RETVAL;
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
#line 291 "lib/Scalar/Number.xs"
	a = string_2num(a);
	b = string_2num(b);
	aiok = Q_IOK_MAYBE_SPURIOUS ? !SvNOK(a) : cBOOL(SvIOK(a));
	biok = Q_IOK_MAYBE_SPURIOUS ? !SvNOK(b) : cBOOL(SvIOK(b));
	anan = !aiok && SvNVX(a) != SvNVX(a);
	bnan = !biok && SvNVX(b) != SvNVX(b);
	if(anan || bnan) {
		RETVAL = newSViv(bnan - anan);
	} else if(Q_HAVE_SIGNED_ZERO &&
			(aiok ? SvUVX(a) == 0 : SvNVX(a) == 0.0) &&
			(biok ? SvUVX(b) == 0 : SvNVX(b) == 0.0)) {
		int atype, btype;
		char tbuf[3];
		if(aiok) {
			atype = 0;
		} else {
			sprintf(tbuf, "%+.f", (double)SvNVX(a));
			atype = tbuf[0] == '-' ? -1 : +1;
		}
		if(biok) {
			btype = 0;
		} else {
			sprintf(tbuf, "%+.f", (double)SvNVX(b));
			btype = tbuf[0] == '-' ? -1 : +1;
		}
		RETVAL = newSViv(atype < btype ? -1 : atype == btype ? 0 : +1);
	} else {
		RETVAL = numscl_val_cmp(a, b);
	}
#line 519 "lib/Scalar/Number.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Scalar__Number); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Scalar__Number)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Scalar::Number::_warnable_scalar_num_part", XS_Scalar__Number__warnable_scalar_num_part, file, "$");
        (void)newXSproto_portable("Scalar::Number::sclnum_is_natint", XS_Scalar__Number_sclnum_is_natint, file, "$");
        (void)newXSproto_portable("Scalar::Number::sclnum_is_float", XS_Scalar__Number_sclnum_is_float, file, "$");
        (void)newXSproto_portable("Scalar::Number::sclnum_val_cmp", XS_Scalar__Number_sclnum_val_cmp, file, "$$");
        (void)newXSproto_portable("Scalar::Number::sclnum_id_cmp", XS_Scalar__Number_sclnum_id_cmp, file, "$$");

    /* Initialisation Section */

#line 182 "lib/Scalar/Number.xs"
{
	int i;
	neg_natint_limit = -1.0;
	pos_natint_limit = +2.0;
	for(i = Q_NATINT_BITS; --i; ) {
		neg_natint_limit += neg_natint_limit;
		pos_natint_limit += pos_natint_limit;
	}
}

#line 573 "lib/Scalar/Number.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
